int main(int argc,char* argv[])
{
  // initialize the ORB
  CORBAContext::instance(argc,argv);

  // acquire a reference to the Logger
  const string loggerName("Logger");
  CORBA_Environment env;
  LoggerService_Logger_ptr logger
    = LoggerService_Logger::_import(CORBAContext::instance().orb(),
                                    loggerName.c_str(),
                                    env);

  if (env.exception())
    cerr << argv[0] << ":  CORBA exception raised:  "
         << CORBAContext::exceptionDescription(env.exception())
         << endl;
  else if (CORBA_is_nil(logger))
    cerr << argv[0] << ":  Cannot obtain a reference for " << loggerName
         << " from the Naming Service." << endl;
  else
    testLogger(logger);
}  // end main
