class LoggerCORBAAdapter : public Logger
{
private:
  static bool isRegistered_;

  LoggerService_Logger_ptr impl_;

protected:
  virtual auto_ptr<Logger> clone();

public:
  // ctors and dtor
  LoggerCORBAAdapter();
  LoggerCORBAAdapter(const LoggerCORBAAdapter& copyFrom);
  virtual ~LoggerCORBAAdapter();

  // error handling

  // operators
  LoggerCORBAAdapter& operator=(const LoggerCORBAAdapter& rhs);
  virtual ostream& print(ostream& s) const;

  // behavior methods
  virtual void logMessage(MessageLevel level,const string& message);
  virtual void logMessage(MessageLevel level,
                          const string& fileName,
                          long lineNumber,
                          const string& message);
  virtual void logMessage(MessageLevel level,
                          const string& className,
                          const string& methodName,
                          const string& message);
  virtual vector<string,allocator> messages(MessageLevel level);

  // friends
};  // end LoggerCORBAAdapter
