#include <stdio.h>
#include <signals/signals.h>

// To compile it with egcs or gcc-2.95 the following line in iostream.h
// had to be commented out:
//    ostream& operator<<(__omanip func) { return (*func)(*this); }

class ClickEvent : public Signal::Event { public: const char* name() const { return "Click"; }};
class Click2Event : public ClickEvent { public: const char* name() const { return "Click2"; }};
class LeaveEvent : public Signal::Event { public: const char* name() const { return "Leave"; }};


class A
{
   public:
   
   A() : a(0) {}
   
   void func() {}
   void cfunc() const {}

   void 
   emit(const Signal::Event& event)
   {
      printf("A::emit(%s)\n", event.name());
      Signal::emit(*this, event);
   }

   void 
   emit(const Signal::Event& event) const
   {
      printf("A::emit(%s) const\n", event.name());
      Signal::emit(*this, event);
   }

   int a;
};

typedef void (A::*CFunc) () const;
typedef void (A::*Func) () ;

class B
{
   public:
   
   void notified (const Signal::Event&, const A&);
//   void    leave (const LeaveEvent&,       A&);
   void    leave (const LeaveEvent&, const A&);
   void    click (const ClickEvent&, A&);
   void   click2 (const Click2Event&, A&);
   
   virtual const char* name() { return "B"; }
};

class C : public B
{
   public:
   
   virtual const char* name() { return "C"; }
};

void
B::notified(const Signal::Event& event, const A& a)
{
   printf("%s::notified(%s)\n", name(), event.name());
}

void
B::leave(const LeaveEvent& event, const A& a)
{
   printf("%s type: B::leave(%s) const.\n", name(), event.name());
}
/*
void
B::leave(const LeaveEvent& event, A& a)
{
   printf("%s type: B::leave(%s).\n", name(), event.name());
}
*/
void
B::click(const ClickEvent& event, A& a)
{
   printf("B::click(%s)\n", event.name());
}

void
B::click2(const Click2Event& event, A& a)
{
   printf("B::click2(%s)\n", event.name());
}

int
main()
{
   A       va;
   const A ca;
   B b;
   C c;
   B& bc = c;
   Func fff = &A::func;
   CFunc cfff = &A::func;

//   (ca.*fff)();
   (ca.*cfff)();

   Signal::connect(va,  b, &B::leave);
   Signal::connect(ca, bc, &B::leave);

//   Signal::connect(a, b, &B::notified);
//   Signal::connect(a, bc, &C::notified);
//   Signal::connect(a, b, &B::click);
//   Signal::connect(a, b, &B::click2);
   
//   a.emit(Signal::Event());
//   a.emit(ClickEvent());
//   a.emit(Click2Event());
   va.emit(LeaveEvent());
   ca.emit(LeaveEvent());

}
