void testLogger(LoggerService_Logger_ptr logger)
{
  CORBA_Environment env;

  logger->logMessage(LoggerService_LOW,"An unimportant test message.",env);
  if (env.exception())
    cerr << "testLogger:  CORBA exception raised:  "
         << CORBAContext::exceptionDescription(env.exception())
         << endl;

  logger->logMessageAndFile(LoggerService_MEDIUM,
                            __FILE__,
                            __LINE__,
                            "A semi-important test message.",
                            env);
  if (env.exception())
    cerr << "testLogger:  CORBA exception raised:  "
         << CORBAContext::exceptionDescription(env.exception())
         << endl;

  logger->logMessageAndMethod(LoggerService_HIGH,
                              "ClassName",
                              "methodName",
                              "A very important test message.",
                              env);
  if (env.exception())
    cerr << "testLogger:  CORBA exception raised:  "
         << CORBAContext::exceptionDescription(env.exception())
         << endl;

  LoggerService_StringSequence* messages
    = logger->messagesByLevel(LoggerService_MEDIUM,env);
  if (env.exception())
    cerr << "testLogger:  CORBA exception raised:  "
         << CORBAContext::exceptionDescription(env.exception())
         << endl;
  else
    {
    cout << "testLogger:  MEDIUM level messages:" << endl;
    for (CORBA_ULong i = 0;i < messages->length();i++)
      cout << "testLogger:  " << (*messages)[i] << endl;
    }
}  // end testLogger(LoggerService_Logger_ptr)
